]> git.pld-linux.org Git - packages/rpm.git/blame - rpm.macros
- it uses bash syntax, maybe should be rewritten
[packages/rpm.git] / rpm.macros
CommitLineData
b52fc1f1 1# $Revision$, $Date$
cc2b296f 2# PLD Linux rpm macros
a8bf9720 3
90c0eaed 4%epoch 0
31b569b6 5%x8664 x86_64 amd64 ia32e
cd33aab7 6
a544555d 7# kernel compiler
6f86c45e 8%kgcc %{__cc}
cabacfeb 9%kgcc_package gcc
a544555d 10
7104afbf
ER
11# compiler version
12%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
48a39d1d 13%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
7104afbf 14
4343a1f7
ER
15%__rm /bin/rm --interactive=never
16
5f9f9bd7 17# Build system path macros.
18#
8af1c6f5
JB
19%__autoconf autoconf %{?debug:-Wall}
20%__automake automake -a -c -f --foreign
429d047e 21%__autopoint autopoint --force
22
aad1c8e4 23%__gettextize { \
4cd84746 24 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
31b569b6 25 gettextize --copy --force --no-changelog; \
93bce43f 26 else \
31b569b6 27 gettextize --copy --force --no-changelog --intl; \
4cd84746
JB
28 fi; \
29 if [ ! -f po/Makevars ]; then \
31b569b6 30 cp -f po/Makevars{.template,}; \
4cd84746 31 fi; \
4cd84746 32}
429d047e 33
34%__glib_gettextize glib-gettextize --copy --force
35%__gnome_doc_common gnome-doc-common --copy
db1adf13 36%__gnome_doc_prepare gnome-doc-prepare --copy --force
429d047e 37%__gtkdocize gtkdocize --copy
38%__intltoolize intltoolize --copy --force
098ff935 39%__libtoolize libtoolize --copy --force --install
5f9f9bd7 40
702e8027 41# Path to top of build area.
135188cb 42%_topdir %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
702e8027 43
38e780ca
ER
44# The number of cvs changelog entries kept when building package.
45%_buildchangelogtruncate 20
46
bd1cd543 47%dependencytracking %{nil}
31b569b6 48
073ae3ba
ER
49# Relations between package names that cause dependency loops
50# with legacy packages that cannot be fixed. Relations are
51# specified as
52# p>q
53# where package p has a Requires: on something that package q Provides:
54#
55# XXX Note: that there cannot be any whitespace within the string "p>q",
56# and that both p and q are package names (i.e. no version/release).
57%_dependency_whiteout %{nil}
58
9ba56d1b 59%_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
1e66cebd 60 && RPM_BUILD_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
96925e1b 61 [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$(($RPM_BUILD_NCPUS * 2))")
cece03f9 62
63#-----------------------------------------------------------------
64#
65# (re)definition of %{rpm*flags} with %filterout_* support
7c9f98ce
ER
66# BuildRequires: awk
67# BuildRequires: rpmbuild(macros) >= 1.315
cece03f9 68#
69# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
a0bf497e 70# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
71# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
63c5d135 72# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
a0bf497e 73# %rpmldflags = %optldflags - %filterout_ld
cece03f9 74#
75# Regular expressions are supported, but to avoid some character be treated
76# as regular expression it must be escaped twice.
77
78%filter_out \
bf66145e 79 for (i = 1; i in I; i++) { A=0; \
cece03f9 80 for (f in F) { \
81 if (I[i] ~ "^" F[f] "$") A=1; \
82 }; \
83 if (!A) printf(I[i] FS); \
84 }
85
86%rpmcflags %(awk 'BEGIN {
87 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
a0bf497e 88 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
cece03f9 89 %{filter_out}
90}')
91
92%rpmcxxflags %(awk 'BEGIN {
a0bf497e 93 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
94 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
cece03f9 95 %{filter_out}
96}')
97
63c5d135
AM
98%rpmcppflags %(awk 'BEGIN {
99 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
100 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
101 %{filter_out}
102}')
103
cece03f9 104%rpmldflags %(awk 'BEGIN {
b699ccff 105 split("%{?optldflags}",I);
cece03f9 106 split("%{?filterout_ld}",F)
107 %{filter_out}
108}')
109
111942c6 110# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
111# but, don't use it, better use gcc as linker
112%ld_rpmldflags %(awk 'BEGIN {
113 split("%{rpmldflags}",F);
114 for (f in F) {
115 s = F[f];
116 if (s ~ /^-Wl,/) {
117 s = substr(s,5);
118 gsub(/,/," ",s);
119 };
120 printf(s FS);
121 };
122}')
123
267cb3a3 124#-----------------------------------------------------------------
125#
126# Generate a command which cleans environment, leaving only the
127# most important variables.
128# If any spec requires any additional environment it should
129# redefine %_preserve_env in following manner:
130#
131# # ADDITIONAL_VAR is required because [a good reason here]
132# %{expand:%%define _preserve_env %_preserve_env ADDITIONAL_VAR}
133
4054dec0 134%_preserve_env PATH HOME TMP TMPDIR
267cb3a3 135
c4a2fa20 136%_clean_env env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
4054dec0
ER
137 split("%{?_preserve_env:%_preserve_env}", P);
138 for (i in P) {
139 p = P[i];
140 if (ENVIRON[p]) {
c4a2fa20 141 split( ENVIRON[p], V, "" );
142 val = p "=";
143 for ( j = 1; j in V; j++ ) {
144 v = V[j];
145 if ( v == q )
146 v = qq;
147 else if ( v == "\\"" )
148 v = q2q;
149 else if ( v == "\\\\" )
150 v = "\\\\\\\\";
151 else
94fc2959 152 gsub( "[^a-zA-Z0-9/:._-]", "\\"&\\"", v );
c4a2fa20 153 val = val "" v;
154 }
155 printf( val " " );
267cb3a3 156 }
157 }
158}')
159
cd33aab7 160#-----------------------------------------------------------------
9f0287b5 161%configure2_13 { \
cd33aab7
AM
162 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
163 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
164 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
af18d245 165 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
cd33aab7 166 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
d4392e78 167 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
63c5d135 168 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
4eac2e49
AM
169 %{?__cc:CC="%{__cc}" ; export CC ; } \
170 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
5b0f0ac9 171 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
fa74a11c 172 --host=%{_target_platform} \
cd33aab7
AM
173 --prefix=%{_prefix} \
174 --exec-prefix=%{_exec_prefix} \
175 --bindir=%{_bindir} \
176 --sbindir=%{_sbindir} \
177 --sysconfdir=%{_sysconfdir} \
178 --datadir=%{_datadir} \
179 --includedir=%{_includedir} \
180 --libdir=%{_libdir} \
181 --libexecdir=%{_libexecdir} \
182 --localstatedir=%{_localstatedir} \
183 --sharedstatedir=%{_sharedstatedir} \
184 --mandir=%{_mandir} \
185 --infodir=%{_infodir} \
c3420100 186 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
8b4be1e1 187 %{dependencytracking} \
cd33aab7
AM
188}
189
53c34296 190%__cmake /usr/bin/cmake
29771119
ER
191%cmake { \
192CC="%{__cc}" \
193CXX="%{__cxx}" \
194CFLAGS="%{rpmcflags}" \
195CXXFLAGS="%{rpmcxxflags}" \
ff219781 196LDFLAGS="%{rpmldflags}" \
53c34296
ER
197%{__cmake} \
198}
199
200# override __scons to add -j4 in your ~/.rpmmacros for parallel make
201%__scons /usr/bin/scons
202%scons { \
203%{__scons} \
13eb0f84
ER
204 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
205 CFLAGS="${CFLAGS:-%rpmcflags}" \
206 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
207 FFLAGS="${FFLAGS:-%rpmcflags}" \
63c5d135 208 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
13eb0f84
ER
209 %{?__cc:CC="%{__cc}"} \
210 %{?__cxx:CXX="%{__cxx}"} \
211 libsuffix=%{_lib} \
212 prefix=%{_prefix} \
29771119
ER
213}
214
ac093701 215# waf. see waf.spec
53c34296 216# override __waf to add -j4 in your ~/.rpmmacros for parallel make
ac093701
ER
217%__waf /usr/bin/waf
218%waf { \
ac093701
ER
219CC="%{__cc}" \
220CXX="%{__cxx}" \
1624498d 221CPP="%{__cpp}" \
ac093701
ER
222CFLAGS="%{rpmcflags}" \
223CXXFLAGS="%{rpmcxxflags}" \
224%{__waf} \
ac093701
ER
225}
226
85f82bec 227#----------------------------------------------------------------
b7626f51 228#%configure_cache 0
43f81f06 229%configure_cache_file %{buildroot}.configure.cache
7e4e3f2b 230
aa1d4266 231%configure {./configure \
85f82bec
AF
232 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
233 CFLAGS="${CFLAGS:-%rpmcflags}" \
af18d245 234 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
85f82bec 235 FFLAGS="${FFLAGS:-%rpmcflags}" \
d4392e78 236 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
63c5d135 237 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
4eac2e49
AM
238 %{?__cc:CC="%{__cc}"} \
239 %{?__cxx:CXX="%{__cxx}"} \
a9bea0f7 240 --host=%{_target_platform} \
85f82bec
AF
241 --build=%{_target_platform} \
242 --prefix=%{_prefix} \
243 --exec-prefix=%{_exec_prefix} \
244 --bindir=%{_bindir} \
245 --sbindir=%{_sbindir} \
246 --sysconfdir=%{_sysconfdir} \
247 --datadir=%{_datadir} \
248 --includedir=%{_includedir} \
249 --libdir=%{_libdir} \
250 --libexecdir=%{_libexecdir} \
251 --localstatedir=%{_localstatedir} \
252 --sharedstatedir=%{_sharedstatedir} \
253 --mandir=%{_mandir} \
254 --infodir=%{_infodir} \
c3420100 255 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
8b4be1e1 256 %{dependencytracking} \
b7626f51 257 %{?configure_cache:--cache-file=%{configure_cache_file}} \
85f82bec
AF
258}
259
9cd5fb46
ER
260# overload to insert debuginfo package
261%prep \
262%if 0%{?_enable_debug_packages}\
263%{debug_package}\
264%endif\
265%%prep\
266%{nil}
267
cd33aab7 268# Location of autoconf macros
742f3bc4 269%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
cd33aab7 270
32720a50 271# Location of omf files
742f3bc4 272%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
32720a50 273
c5eece2c 274# Location of pkgconfig files
a46897a7 275%_pkgconfigdir /usr/%{_lib}/pkgconfig
e2023017
JB
276# noarch pkgconfig files
277%_npkgconfigdir /usr/share/pkgconfig
c5eece2c 278
c917274d 279# Location of desktop files
280%_desktopdir /usr/share/applications
510f694c 281%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
c917274d 282
fb08fb4a 283# Location of pixmaps for applnk/desktop files
3a9bb008 284%_pixmapsdir /usr/share/pixmaps
cd33aab7 285
fb08fb4a 286# Location of themable icons for applnk/desktop files
986c3bcd 287%_iconsdir /usr/share/icons
288
c5eece2c
JB
289# Location of fonts directories
290%_fontsdir /usr/share/fonts
291
5cfcbc9e 292# Location of Gtk and associated libraries documentation
43f81f06 293%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
5cfcbc9e 294
eee08b2d 295# Location of KDE documentation
43f81f06 296%_kdedocdir %{_defaultdocdir}/kde/HTML
eee08b2d 297
a7cad6ae 298# unsermake script
299%__unsermake /usr/share/unsermake/unsermake
300
cd33aab7 301# Current date
3a8f973a 302%date %(LC_ALL=C date +"%a %b %d %Y")
cd33aab7 303
cd33aab7
AM
304# Example files, programs, scripts...
305%_examplesdir /usr/src/examples
306
7127e0fc 307# Alternative kernel type/version
c604d0a9 308%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
7127e0fc 309
bd63739a 310# The directory holding Linux kernel sources
c604d0a9 311%_kernelsrcdir /usr/src/linux%{_alt_kernel}
bd63739a 312
cd33aab7 313# If non-empty "debug" macro defined, add "dbg" suffix to release number
5b0f0ac9 314%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
cd33aab7 315
5b0f0ac9 316# Requires name = version-release
3a8f973a 317%requires_releq() %(Z=$(echo '%*' | LC_ALL=C xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n'); if echo "$Z" | ! grep -v '^Requires:'; then echo "$Z"; fi)
511ee4c6 318
135188cb
ER
319%releq_kernel %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
320%releq_kernel_up %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
321%releq_kernel_smp() %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
d606f9ca
ER
322%requires_releq_kernel(s:) Requires%{-s:(%{-s*})}: %releq_kernel
323%requires_releq_kernel_up(s:) Requires%{-s:(%{-s*})}: %releq_kernel_up
324%requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
511ee4c6 325
3a8f973a
ER
326# Requires: name = version
327%requires_eq() %(Z=$(echo '%*' | LC_ALL=C xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n'); if echo "$Z" | ! grep -v '^Requires:'; then echo "$Z"; fi)
328# Requires: name = version (version based on querying package %2)
329%requires_eq_to() %(%{!?2:echo "ERROR: missing param 2 to %%requires_eq_to"}%{?2:Z=$(LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not"); echo ${Z:-[%%requires_eq_to %1 %2] expanded to nothing}})
e478b9e7 330
a1551c98 331%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
8dea1306 332
333# kernel version-release handling
1c1268c5
ER
334%__kernel_ver %{expand:%%global __kernel_ver %( \\
335 Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
336 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
337 echo ${Z:-ERROR}; \\
91897f8e 338)}%__kernel_ver
1c1268c5 339
a1551c98
ER
340%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
341%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
342%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
343%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
fd4d8ee0 344
63fcfda0
ER
345# `uname -r` to be used in @release field
346%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
347
c2c27a5a 348# sgml macros
31b569b6
ER
349%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
350%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
351%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
352%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
353%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
354%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
c2c27a5a 355%docbook_sgmlcat_fix() { for l in \
356'' \
357' -- default decl --' \
358'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
359' -- hacks for opensp --' \
360'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
361'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
362'' \
363; do echo $l; done >> %1 \
364}
365
31bd34a8
ER
366# vim - "
367
f3f40db8
ER
368# minimum file size needed for compressed documents.
369# just smaller files than this get larger when compressed.
cdbfc157
ER
370# some stats:
371# - 0 byte file compressed was 25 bytes .gz
372# - 39 byte file was compressed as 57
373# - with test/test.spec@man 158 byte file was compressed also 158
374%_min_compress_bytes 159
f3f40db8 375
cd33aab7
AM
376#-----------------------------------------------------------------
377# find and gzip all files in %{_mandir} and %{infodir}
378#
379# Requires: xargs, find
380#
381#%no_install_post_compress_docs 1
382%__spec_install_post_compress_docs { \
f67bd19e 383%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
026ed59b 384 for i in /usr/share/man /usr/X11R6/man; do \
cd33aab7 385 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
026ed59b 386 echo "Compress man pages: $i"; \
f3f40db8
ER
387 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
388 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
38e531f0
ER
389 find $RPM_BUILD_ROOT$i -type l | while read a; do \
390 m=$(readlink $a); \
391 rm -f $a; \
392 echo .so ${m##*/} > $a; \
393 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
394 done; \
f3f40db8 395 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
cd33aab7
AM
396 fi; \
397 done; \
91bfff1c
JB
398 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
399 echo "Compress info pages: %{_infodir}"; \
400 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
401 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
402 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
026ed59b 403 fi; \
f67bd19e 404}; __spec_install_post_compress_docs } }
cd33aab7
AM
405
406#-----------------------------------------------------------------
407# Strip executable binaries and shared object files
408#
409# Requires: find, awk, strip, cut, xargs
410#
ee170415
JB
411# Special macros which affect this process:
412#%no_install_post_strip 1 # disable stripping at all
413#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
414#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
415#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
416#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
417#
cd33aab7 418%__spec_install_post_strip {%{!?debug: \
f67bd19e 419%{!?no_install_post_strip:__spec_install_post_strip() { \
65e03cc0 420if [ -d "$RPM_BUILD_ROOT" ]; then \
31bd34a8
ER
421 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
422 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
fefadad0
ER
423 if [ "$modulelist" ]; then \
424 modulecount=$(echo "$modulelist" | wc -l); \
7f1d3873 425 printf "Stripping %d kernel modules..." $modulecount; \
6cf69412
ER
426 echo "$modulelist" | xargs -l512 chmod u+w; \
427 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
428 echo "DONE"; \
429 fi; \
31bd34a8 430 fi; \
559c4907 431 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
d65f5d0e
JB
432 if [ -n "$filelist" ]; then \
433 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
434 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
435 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
ee170415 436 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
d65f5d0e 437 if [ -n "$elfexelist" ]; then \
fefadad0 438 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
d65f5d0e
JB
439 chmod u+w $elfexelist; \
440 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
441 echo "DONE"; \
442 fi; \
443 if [ -n "$elfsharedlist" ]; then \
fefadad0 444 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
d65f5d0e
JB
445 chmod u+w $elfsharedlist; \
446 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
447 echo "DONE"; \
448 fi; \
449 if [ -n "$archiveslist" ]; then \
fefadad0 450 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
d65f5d0e
JB
451 chmod u+w $archiveslist; \
452 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
453 echo "DONE"; \
454 fi; \
65e03cc0 455 fi; \
559c4907
ER
456 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
457 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
458 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
d65f5d0e 459 if [ -n "$filelist_all" ]; then \
fefadad0 460 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
ee170415 461 chmod u+w $filelist_all; \
d65f5d0e 462 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
fc87add2 463 echo "DONE"; \
cd33aab7 464 fi; \
d65f5d0e 465 if [ -n "$filelist_unneeded" ]; then \
fefadad0 466 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
ee170415 467 chmod u+w $filelist_unneeded; \
d65f5d0e 468 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
fc87add2 469 echo "DONE"; \
5b0f0ac9 470 fi; \
d65f5d0e 471 if [ -n "$filelist_debug" ]; then \
fefadad0 472 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
ee170415 473 chmod u+w $filelist_debug; \
d65f5d0e 474 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
fc87add2 475 echo "DONE"; \
f80cefa3 476 fi; \
f67bd19e 477fi; }; __spec_install_post_strip } } }
31b569b6 478
cc545e1a 479#-----------------------------------------------------------------
480# remove all RPATH from executable binaries and shared object files
481#
482# Requires: find, awk, cut, xargs, chrpath, uname
483#
ee170415
JB
484# Special macros which affect this process
485#%no_install_post_chrpath 1 # disable chrpath at all
486#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
487#
cc545e1a 488%__spec_install_post_chrpath {%{!?debug: \
f67bd19e 489%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
f80cefa3 490if [ -d "$RPM_BUILD_ROOT" ]; then \
559c4907 491 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
65e03cc0 492 if [ -n "$files" ]; then \
0faed11b 493 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
fd3a42b0 494 fi; \
65e03cc0 495 if [ -n "$objs" ]; then \
fefadad0 496 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
65e03cc0
ER
497 echo "$objs" | \
498 while read file; do \
499 rpath= ; \
500 chmod u+w "$file"; \
ebc04679 501 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
92a43428
AM
502 case $dir in \
503 '$ORIGIN' ) \
504 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
505 else rpath="$rpath:$dir" ; fi ; \
506 continue ; \
507 ;; \
508 esac ; \
b2ed5f3d
AM
509 newdir=$(readlink -m "$dir"); \
510 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
65e03cc0
ER
511 case $dir in \
512 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
513 echo "remove-rpath: $dir in $file"; \
514 ;; \
515 * ) \
516 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
517 else rpath="$rpath:$dir" ; fi ; \
518 ;; \
519 esac ; \
520 done ; \
521 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
522 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
523 done; \
524 fi; \
f67bd19e 525fi; }; __spec_install_post_chrpath } } }
31b569b6 526
f173029a
AM
527#-----------------------------------------------------------------
528# Find all shared object files with unresolved symbols. Warn
529# and terminate if any found (termination can be turned off by define).
530#%no_install_post_check_so 1
531%__spec_install_post_check_so { \
532 __spec_install_post_check_so() { \
533 fail=0; \
534 printf "Searching for shared objects with unresolved symbols..."; \
7643f7e1 535 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
1dcf239c 536 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
f173029a
AM
537 done ; \
538 echo " DONE"; \
c1f91a8d 539 %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
f173029a
AM
540}; __spec_install_post_check_so }}
541
22a54b3e 542#-----------------------------------------------------------------
93b46c00 543# Find and gzip all kernel modules
544#
545# Requires: find
546#
43f81f06 547#%no_install_post_compress_modules 1
93b46c00 548%__spec_install_post_compress_modules { \
f67bd19e 549%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
9cf7c1b9 550 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
9cf7c1b9 551 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
fefadad0
ER
552 if [ "$q" ]; then \
553 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
554 echo "$q" | xargs -r %{__gzip} -9nf; \
555 echo "DONE"; \
556 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
557 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
558 fi; \
31b569b6 559 fi; \
f67bd19e 560}; __spec_install_post_compress_modules } }
cd33aab7 561
e4d71427
ER
562# Remove common Perl files we don't package
563%__spec_install_post_perl_clean {\
564%{!?no_install_post_perl_clean: \
565%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
566} }
567
aad1c8e4 568#-----------------------------------------------------------------
cc6c554c 569# Update GConf2 schemas
aad1c8e4 570#
571# Requires: GConf2
572#
5b8ed3c0 573%gconf_schema_install() \
b7f351b9
ER
574 umask 022; \
575 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
576 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
2b633092 577%{nil}
5b8ed3c0 578
579%gconf_schema_uninstall() \
d143d064 580if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
31b569b6 581 umask 022; \
d143d064
ER
582 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
583 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
2b633092 584fi; \
429d047e 585%{nil}
586
587#-----------------------------------------------------------------
588# Update desktop MIME database
96999189 589# requires: desktop-file-utils
7ec40643 590%update_desktop_database() {{ \
429d047e 591 umask 022; \
db1adf13 592 /usr/bin/update-desktop-database -q; \
e26a0fcc
MB
593};} \
594%{nil}
429d047e 595
7ec40643
ER
596%update_desktop_database_post %update_desktop_database
597
598%update_desktop_database_postun() {{ \
2b633092 599if [ "$1" = "0" ]; then \
e26a0fcc 600 %update_desktop_database \
2b633092 601fi; \
e26a0fcc
MB
602};} \
603%{nil}
429d047e 604
db1adf13 605#-----------------------------------------------------------------
606# Update shared MIME info database
607# requires: shared-mime-info
608#
7ec40643 609%update_mime_database() {{ \
db1adf13 610 umask 022; \
611 /usr/bin/update-mime-database %{_datadir}/mime; \
e26a0fcc
MB
612};} \
613%{nil}
db1adf13 614
615#-----------------------------------------------------------------
616# Update icon cache
617# requires: gtk+
618#
7ec40643 619%update_icon_cache() {{ \
db1adf13 620 umask 022; \
8ffd1cc2 621 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
e26a0fcc
MB
622};} \
623%{nil}
db1adf13 624
429d047e 625#-----------------------------------------------------------------
626# Update scrollkeeper database
627# requires: scrollkeeper
628#
629%scrollkeeper_update_post() \
429d047e 630 /usr/bin/scrollkeeper-update -q; \
2b633092 631%{nil}
429d047e 632
633%scrollkeeper_update_postun() \
2b633092 634if [ "$1" = "0" ]; then \
429d047e 635 /usr/bin/scrollkeeper-update -q; \
2b633092 636fi; \
429d047e 637%{nil}
638
cd33aab7
AM
639#-----------------------------------------------------------------
640# post %install sequence:
641# - autodeps exceptions
642# - compress all man and info pages,
643# - strip all ELF executables and ELF shared objects if not %debug.
5b0f0ac9 644# - compress kernel modules if any
cd33aab7
AM
645
646###################################################################
647# Requires/Provides automation
f9e8b64d 648# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
a4852742 649#
fbbdca08
JB
650%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
651%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
652%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
653%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
654%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
a1551c98 655
a4852742
JB
656#%_noautocompressdoc %{nil}
657#
5b0f0ac9
MM
658%_missing_doc_files_terminate_build 1%{nil}
659%_unpackaged_files_terminate_build %{nil}
4c7d3ba4 660# (X)emacs support
42b7e5ac 661%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
a1551c98
ER
662%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
663%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
41a62699 664
984f6de6
JK
665%__php_provides %{nil}
666%__php_requires %{nil}
667%__perl_provides %{nil}
668%__perl_requires %{nil}
63b0a9d7 669%__mono_provides %{nil}
670%__mono_requires %{nil}
41a62699
AF
671
672# Perl specific macro definitions.
a1551c98
ER
673%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
674%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
675%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
676%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
677%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
678%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
41a62699 679
cb84f517 680# Ruby
a1551c98
ER
681%__ruby /usr/bin/ruby
682%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
683%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
684%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
685%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
686%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
687%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
688%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
7de443fe 689%ruby_rdocdir /usr/share/rdoc
a1551c98 690%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
5483bb35
ER
691%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
692%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
cb84f517 693
3da52f86 694%php_pear_dir /usr/share/pear
ef62b6ce 695%php_data_dir /usr/share/php
a1551c98
ER
696%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
697%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
698%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
41a62699 699
f73da51b 700# extract php/zend api versions
a1551c98
ER
701%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
702%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
703%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
704%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
705%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
706%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
707%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
6b2157a6
ER
708
709# helper macro
e255dfdc 710%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
6b2157a6
ER
711
712# macros for public use
713# for php extensions (php-pecl)
ab8d73ee 714%requires_php_extension %{__php_api_requires modules_api php_api_version} \
cc2b296f 715%{__php_api_requires zend_module_api} \
e255dfdc
ER
716%{__php_api_requires -v %php_major_version debug php_debug} \
717%{__php_api_requires -v %php_major_version thread-safety zend_zts}
ab8d73ee 718
6b2157a6
ER
719# for zend extensions
720%requires_zend_extension %{__php_api_requires zend_module_api} \
ab8d73ee 721%{__php_api_requires zend_extension_api} \
e255dfdc
ER
722%{__php_api_requires -v %php_major_version debug php_debug} \
723%{__php_api_requires -v %php_major_version thread-safety zend_zts}
6b2157a6 724
1c107a2d
ER
725# for php pdo modules (php-pecl-PDO_*)
726%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
727
e6ca24e8
ER
728# for using PHP post scripts. for PHP >= 5.0
729%php_webserver_restart \
730[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
febce2c9 731[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
b4080c85
ER
732if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
733 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
734 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
735 %service -q php-fcgi restart \
736 fi \
737fi \
e6ca24e8
ER
738%{nil}
739
740# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
741%php4_webserver_restart \
742[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
febce2c9 743[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
b4080c85
ER
744if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
745 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
746 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
747 %service -q php-fcgi restart \
748 fi \
749fi \
e6ca24e8
ER
750%{nil}
751
b89f672e 752# X.org helper macros
14109c0c
ER
753%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
754%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
755
a1551c98
ER
756%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
757%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
758%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
759%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
760%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
b89f672e 761
14109c0c 762%requires_xorg_xserver_extension \
08fe4a98
AM
763%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
764%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
765%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
766%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
14109c0c
ER
767%{nil}
768
769%requires_xorg_xserver_xinput \
08fe4a98
AM
770%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
771%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
772%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
773%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
14109c0c
ER
774%{nil}
775
776%requires_xorg_xserver_font \
08fe4a98
AM
777%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
778%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
779%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
780%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
14109c0c
ER
781%{nil}
782
783%requires_xorg_xserver_videodrv \
08fe4a98
AM
784%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
785%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
786%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
787%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
14109c0c 788%{nil}
b89f672e 789
41a62699
AF
790# Python specific macro definitions.
791# python main version
6e4fcea0 792%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
41a62699
AF
793
794# directories
6e4fcea0 795%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
31b569b6 796%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
a4f0b5e0 797%py_scriptdir %{py_prefix}/share/python%{py_ver}
31b569b6 798%py_incdir /usr/include/python%{py_ver}
3da52f86 799%py_sitedir %{py_libdir}/site-packages
a4f0b5e0 800%py_sitescriptdir %{py_scriptdir}/site-packages
31b569b6 801%py_dyndir %{py_libdir}/lib-dynload
41a62699
AF
802
803# pure python modules compilation
31b569b6 804%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
41a62699 805
31b569b6 806%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
41a62699
AF
807
808# Software written in Python language require Python with main version
5177c7b1 809%pyrequires_eq() Requires: %1
41a62699 810
ea4b2900 811# Hardlink binary identical .pyc and .pyo files
ea4b2900 812%__spec_install_post_py_hardlink {\
f67bd19e 813%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
5418b502
ER
814local a b c=0 t=0; \
815if [ -d "$RPM_BUILD_ROOT" ]; then \
816 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
817 while read a; do \
818 b="${a%.pyc}.pyo"; \
819 if cmp -s "$a" "$b"; then \
820 ln -f "$a" "$b"; \
821 c=$((c + 1)); \
822 fi; \
823 t=$((t + 1)); \
824 done < __rpm_pyc; \
825 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
826 rm -f __rpm_pyc; \
827fi; \
f67bd19e 828}; __spec_install_post_py_hardlink } }
ea4b2900 829
16f6f416 830# remove python sources, so that check-files won't complain
ea4b2900 831%py_postclean() \
e4e8948b 832for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
9ba5542a 833 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
ea4b2900
AF
834done \
835%{nil}
836
67ed5b97 837# depmod macro
838%depmod() { \
fe30b3ea 839umask 022; \
67ed5b97 840if [ -e /boot/System.map-%1 ]; then \
31b569b6 841 /sbin/depmod -a -F /boot/System.map-%1 %1; \
67ed5b97 842else \
31b569b6
ER
843 if [ -e /boot/System.map ]; then \
844 /sbin/depmod -a -F /boot/System.map %1; \
845 else \
846 /sbin/depmod -a %1; \
847 fi \
67ed5b97 848fi; \
849}
850
495892af 851# XMMS specific macros
a1551c98
ER
852%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
853%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
854%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
855%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
856%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
857%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
858%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
859%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
860%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
861%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
862
863%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
bb128216 864
e3618ee9 865# user/group checking macros
866#
867# Usage:
868# %userremove myuser
869#
870%userremove /usr/lib/rpm/user_group.sh user del
871%groupremove /usr/lib/rpm/user_group.sh group del
872#
873# Usage:
874# if %usertestrm myuser; then
875# /usr/sbin/userdel -r myuser
876# Note:
877# use these macros only if you need to call userdel/groupdel with
878# a non-standard option or take an extra action; otherwise use the
879# %userremove/%groupremove macros
880#
881%usertestrm /usr/lib/rpm/user_group.sh user testrm
882%grouptestrm /usr/lib/rpm/user_group.sh group testrm
13f70a2c
JK
883# user group membership management macros
884#
885# Usage:
886# %addusertogroup myuser agroup
887#
888%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
bfd9689c 889
890# banner support (useful in {pre,post}{,un} and triggers)
891#
892# Usage:
a980efc1 893# %banner name [-a] [-e] [-n] [-tn] <<EOF
bfd9689c 894# the banner text, the banner text
a980efc1
ER
895# the banner text, and following line
896#EOF
897# You can use any form of here-document, <<'EOF' <<-EOT will do.
898# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
899#
bfd9689c 900# -a - append to the banner
fb033326 901# -e - send to stderr instead of stdout
1257c400 902# -n - no show banner (overrides -t)
903# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
4055114a
ER
904#
905# Tests:
906# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
907# rpm -E 'date | %banner -e banner' > m; sh -x m
908#
8bea2501 909%banner(aent:) ( \
f1bbc6ff 910RPM_SCRIPTVERBOSITY=5 \
911[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
912if [ -x /usr/bin/banner.sh ]; then \
a980efc1 913 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
f1bbc6ff 914else \
fb033326 915 CMD="cat%{-e: >&2}" \
f1bbc6ff 916fi \
4055114a
ER
917eval $CMD %{?2:%2}%{?3: %3}) \
918%{nil}
1257c400 919
3c972982 920# useradd/groupadd macros
1ebc460a 921# Author: Elan Ruusamäe <glen@pld-linux.org>
29c5556c
ER
922#
923# Usage:
924# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
925# [-g initial_group] [-G group[,...]] login
926#
927# -u uid. REQUIRED
928# -g gid/group. REQUIRED
929# -s defaults to /bin/false
930# -d defaults to /usr/share/empty
931# -c No default
932# -r is accepted but ignored (it's always set)
6eb25d5d 933# -k skeleton dir. defaults to /usr/share/empty
29c5556c
ER
934# rpm specific flags
935# -P package name. defaults to %{name}
936#
29c5556c 937%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
0044d46f
ER
938%{!-u:%{error:useradd: Required argument -u missing}} \
939%{!-g:%{error:useradd: Required argument -g missing}} \
940%{!?1:%{error:useradd: Required parameter login missing}} \
29c5556c
ER
941if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
942 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
943 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
944 exit 1 \
945 fi \
946else \
947 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
948 /usr/sbin/useradd \\\
cc333c8b 949 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
29c5556c
ER
950 -u %{-u*} \\\
951 -r \\\
952 -d %{-d*}%{!-d:/usr/share/empty} \\\
953 -s %{-s*}%{!-s:/bin/false} \\\
85e3e9a1 954 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
29c5556c
ER
955 -g %{-g*} \\\
956 %{-M} \\\
957 %{-G:-G %{-G*}} \\\
6750d9f5 958 %{expand:%{%{#}}} 1>&2 || exit $? \
52e30914 959 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
29c5556c
ER
960fi;
961
29c5556c
ER
962# Usage:
963# %groupadd [-P package] [-g gid] group
964#
965# -g gid. REQUIRED
966#
967# Sample:
968# %groupadd -P %{name}-base -g %{gid} %{name}
969
970%groupadd(g:P:rfo) \
0044d46f
ER
971%{!-g:%{error:groupadd: Required argument -g missing}} \
972%{!?1:%{error:groupadd: Required parameter group missing}} \
9b773c34 973if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
29c5556c
ER
974 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
975 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
976 exit 1 \
977 fi \
978else \
979 echo "Adding group %{1} GID=%{-g*}." \
6750d9f5 980 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
52e30914 981 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
29c5556c 982fi;
053b8de1 983
55a50f1a 984# webapp macros
1ebc460a 985# Author: Elan Ruusamäe <glen@pld-linux.org>
ba42a822
ER
986#
987# The config is installed/removed inside trigger, this means that you can any
988# time install apache1/apache/lighttpd package and the configuration file is
43f81f06 989# updated. if you don't need the config for various reason for specific
ba42a822
ER
990# webserver, just remove the symlink from config directory using webapp
991# program. the trigger will not recreate the symlink on upgrades. In other
992# words the config is linked to webserver config directory on first install of
993# PACKAGE or WEBSERVER.
994#
55a50f1a
ER
995# Add package's webserver config to webserver webapps dir.
996# Usage:
217f2cb2 997# %webapp_register WEBSERVER WEBAPP
ba42a822
ER
998#
999%webapp_register() \
1000%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1001if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1002 /usr/sbin/webapp register %1 %2\
1003fi\
973c1dc7 1004# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
afe4f5f0 1005if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
5f0b2e29 1006 %{expand:%service -q %%1 reload}\
ba42a822
ER
1007fi\
1008%{nil}
1009
1010# Remove package's config from webserver webapps dir.
ba42a822 1011# Usage:
b9588fe6
ER
1012# %webapp_register [-f] WEBSERVER WEBAPP
1013%webapp_unregister(f) \
ba42a822
ER
1014%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1015# remove link if either of the packages are gone \
afe4f5f0 1016if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
217f2cb2 1017 /usr/sbin/webapp unregister %1 %2\
5f0b2e29 1018 %{expand:%service -q %%1 reload}\
ba42a822
ER
1019fi \
1020%{nil}
1021
8edf8498 1022# service macro.
1ebc460a 1023# Author: Elan Ruusamäe <glen@pld-linux.org>
8edf8498
ER
1024#
1025# calls usual service restart on package %post, but skips the restart if
1026# administrator has disabled automatic service restarts in either global
1027# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1028#
8edf8498 1029# Usage:
378ae5eb 1030# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
8edf8498 1031#
dd4e969a 1032# -q be silent when service isn't started (for scriplets restaring other package's services)
378ae5eb 1033# -n NOOP mode, do not actually restart service
8edf8498 1034#
378ae5eb
ER
1035# Requirements:
1036# BuildRequires: rpmbuild(macros) >= 1.268
1037# Requires: rc-scripts
1038# -n option:
1039# BuildRequires: rpmbuild(macros) >= 1.450
1040%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
cec3a041
ER
1041
1042
91bd3172
ER
1043# Java macros. based on jpackage macros.java
1044#
1045# Root directory where all Java VMs/SDK/JREs are installed.
93406dd9 1046%_jvmdir %{_libdir}/jvm
91bd3172
ER
1047
1048# Root directory where all Java VMs/SDK/JREs expose their jars
93406dd9 1049%_jvmjardir %{_libdir}/jvm-exports
91bd3172
ER
1050
1051# Root directory for all Java VM/SDK/JRE's private things.
1052%_jvmprivdir %{_libdir}/jvm-private
1053
1054# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
93406dd9 1055%_jvmlibdir %{_libdir}/jvm
91bd3172
ER
1056
1057# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1058%_jvmdatadir %{_datadir}/jvm
1059
1060# Root directory for all configurations parts of Java VM/SDK/JRE's
1061%_jvmsysconfdir %{_sysconfdir}/jvm
1062
1063# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
29959405 1064%_jvmcommonlibdir %{_libdir}/jvm-common
91bd3172
ER
1065
1066# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
29959405 1067%_jvmcommondatadir %{_datadir}/jvm-common
91bd3172
ER
1068
1069# Root directory for all common configurations parts of Java VM/SDK/JRE's
29959405 1070%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
91bd3172
ER
1071
1072# Directory where arch-specific (JNI) version-independent jars are installed.
93406dd9 1073%_jnidir %{_libdir}/java
91bd3172 1074
a1551c98 1075%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
cec3a041 1076
95e3fc87 1077%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
43f81f06 1078%jar %{java_home}/bin/jar
a1551c98 1079%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
43f81f06
ER
1080%javac %{java_home}/bin/javac
1081%javadoc %{java_home}/bin/javadoc
cec3a041 1082
43f81f06 1083%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
cec3a041
ER
1084
1085%jpackage_script() \
a2047fce
ER
1086install -d $RPM_BUILD_ROOT%{_bindir}\
1087cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
cec3a041
ER
1088#!/bin/sh\
1089#\
1090# %{name} script\
1091# JPackage Project <http://www.jpackage.org/>\
1092\
1093# Source functions library\
1094. %{_javadir}-utils/java-functions\
1095\
1096# Source system prefs\
a2047fce 1097if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
43f81f06 1098 . %{_sysconfdir}/java/%{name}.conf\
cec3a041
ER
1099fi\
1100\
1101# Source user prefs\
a2047fce
ER
1102if [ -f $HOME/.%{name}rc ]; then\
1103 . $HOME/.%{name}rc\
cec3a041
ER
1104fi\
1105\
1106# Configuration\
1107MAIN_CLASS=%1\
1108BASE_FLAGS=%2\
1109BASE_OPTIONS=%3\
a2047fce 1110BASE_JARS="%(echo %4 | tr ':' ' ')"\
cec3a041
ER
1111\
1112# Set parameters\
1113set_jvm\
a2047fce
ER
1114set_classpath $BASE_JARS\
1115set_flags $BASE_FLAGS\
1116set_options $BASE_OPTIONS\
cec3a041
ER
1117\
1118# Let's start\
a2047fce 1119run "$@"\
cec3a041
ER
1120EOF
1121
d449d2c8
ER
1122# jpackage 1.7
1123# Directory for maven depmaps
1124#
1125%_mavendepmapdir /etc/maven
1126%_mavendepmapfragdir /etc/maven/fragments
1127
1128#
1129# add_to_depmap adds an entry to the depmap. The arguments are:
1130#
1131# %1 the original groupid
1132# %2 the original artifact id
1133# %3 the version
1134# %4 the new groupid
1135# %5 the new artifactid
1136#
1137
1138%add_to_maven_depmap() \
1139install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1140cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1141<dependency>\
1142 <maven>\
1143 <groupId>%1</groupId>\
1144 <artifactId>%2</artifactId>\
1145 <version>%3</version>\
1146 </maven>\
1147 <jpp>\
1148 <groupId>%4</groupId>\
1149 <artifactId>%5</artifactId>\
1150 <version>%3</version>\
1151 </jpp>\
1152</dependency>\
1153\
1154EOF\
1155%{nil}
1156
1157#==============================================================================
1158#
1159# update_maven_depmap updates the main maven depmap
1160#
1161%update_maven_depmap() \
1162echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1163if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1164cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1165fi\
1166echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1167
1168
e22fc3d1 1169# PEAR install macros
1ebc460a 1170# Author: Elan Ruusamäe <glen@pld-linux.org>
d2a29d34
ER
1171#
1172# Usage:
3735468f 1173# %%pear_package_setup ...
d2a29d34 1174#
e22fc3d1 1175# -a # - also unpack SOURCE#. for PEAR bootstrapping
d2a29d34 1176# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
e22fc3d1 1177# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
3735468f
ER
1178# -D - pass -D to %setup (so the build dir is not removed)
1179# -c - register channel from local channel.xml file
d2a29d34
ER
1180#
1181# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1182# destination hierarchy. you should copy the tree to buildroot after
1183# patching/reorganizing with %%pear_package_install.
1184#
1185# additionally BUILDROOT is stripped from files and files are converted to UNIX
1186# line endings.
1187#
1188# the pear install process output is recorded to install.log, you should put it
a4f06f46 1189# to %%doc for later debug or just for information.
d2a29d34
ER
1190#
1191# additionally additional-packages.txt is produced if it was detected that the
1192# package has optional dependencies. the file format is suitable of displaying
1193# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1194# automatically added for this file.
e22fc3d1
ER
1195
1196
1197# records install.log and transforms PEAR names to PLD Linux rpm package names.
1198%__pear_install_log \
1199tee install.log \
1200# make post message of optional packages \
96e58997 1201grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
e22fc3d1
ER
1202if [ -s optional-packages.txt ]; then \
1203 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1204else \
1205 rm -f optional-packages.txt \
1206fi \
1207%{nil}
1208
1209# command invoking pear cli
1210%__pear /usr/bin/pear
1211
856feeea 1212%pear_install(a:n:zD) \
e22fc3d1 1213%__pear \\\
3735468f 1214 -c %{builddir}/pearrc \\\
d2a29d34 1215 -d doc_dir=/docs \\\
3735468f
ER
1216 -d temp_dir=/tmp \\\
1217 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
d2a29d34
ER
1218 -d bin_dir=%{_bindir} \\\
1219 -d data_dir=%{php_pear_dir}/data \\\
1220 -d test_dir=%{php_pear_dir}/tests \\\
1221 install \\\
e22fc3d1 1222 --packagingroot=%{builddir} \\\
d2a29d34
ER
1223 --offline \\\
1224 --nodeps \\\
1225 %{-f:--force} \\\
856feeea 1226 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
2a0f3b08 1227 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
856feeea
ER
1228%{nil}
1229
1230# The main macro.
1231# using this macro will append optional-packages.txt to the nocompressdoc list
1232# as it's displayed to user after package install. and adding additional gzip
1233# dep is just waste ;)
3735468f 1234%pear_package_setup(a:n:zDc:) \
856feeea
ER
1235%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1236%define builddir %{_builddir}/%{srcdir} \
1237%setup -q -c -T %{-D:-D} -n %{srcdir} \
1238%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1239%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
3735468f 1240%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
856feeea 1241%pear_install \
e22fc3d1
ER
1242%{-z:cd ..} \
1243cat %{-z:$_N/}.install.log | %__pear_install_log \
1244\
d2a29d34 1245# undos sources \
07fa2259 1246find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
d2a29d34
ER
1247%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1248%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1249%{nil}
1250
0aced28c 1251# Copies exctracted PEAR package structure and PEAR registry to buildroot.
1ebc460a 1252# Author: Elan Ruusamäe <glen@pld-linux.org>
d2a29d34
ER
1253%pear_package_install() \
1254cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1255find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1256# help the developer out a little: \
1257if [ -f _noautoreq ]; then \
1258 echo "AutoReqdep detected:" \
1259 echo "_noautoreq $(cat _noautoreq)" \
1260fi \
1261%{nil}
1262
54294c49
ER
1263
1264# Register OpenLDAP schema.
1ebc460a 1265# Author: Elan Ruusamäe <glen@pld-linux.org>
54294c49
ER
1266#
1267# Usage:
1268# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1269#
1270# -d specify dependant schemas, separated by comma
1271#
1272%openldap_schema_register(d:) \
1273for schema in %*; do \
1274 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1275 %{__sed} -i -e " \
1276 /^include.*local.schema/{ \
1277 iinclude\\t $schema\
1278 } \
1279 " /etc/openldap/slapd.conf \
1280 fi \
1281done \
1282# enable dependant schemas \
1283if [ "%{-d*}" ]; then \
1284 %{__sed} -i -e ' \
1285 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1286 s/^#// \
1287 }' /etc/openldap/slapd.conf \
1288fi \
1289%{nil}
1290
1291# Unregister OpenLDAP schema.
1ebc460a 1292# Author: Elan Ruusamäe <glen@pld-linux.org>
54294c49
ER
1293#
1294# Usage:
1295# %%openldap_schema_unregister %{schemadir}/horde.schema
1296#
1297%openldap_schema_unregister() \
1298for schema in %*; do \
1299 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1300 %{__sed} -i -e " \
1301 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1302 # for symmetry it would be nice if we disable enabled schemas in post, \
1303 # but we really can not do that, it would break something else. \
1304 " /etc/openldap/slapd.conf \
1305 fi \
1306done \
1307%{nil}
1308
feb61fae 1309%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
6ee06092 1310
a4623211 1311
1312# Build modules for kernels 2.6
1313# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1314#
1315# Usage:
650cc681 1316# %build_kernel_modules -m <modules> -C <directory>
a4623211 1317#
1318# remember that proper Makefile is still required
1319# Options:
3c972982 1320# -m <modules> (required) -- comma-separated list of modules to save,
a4623211 1321# without .ko extension, may be placed in subdirectory
650cc681 1322# -C <directory> -- change to <directory> before doing anything
a4623211 1323# -p <arg>, -P <arg> -- arguments passeed to make scripts
bf97e3a6 1324# -c -- do not execute make clean
a4623211 1325# <additional arguments> -- all additional arguments will be passed to
1326# make modules
1327#
1328# Additional patching supported via here document. Try:
1329# %build_kernel_modules -m module <<'EOF'
1330# your patch script here
1331# EOF
1332# Don't use it unless patching depends on config options.
1333
1334# Developer note: don't touch it unless you know how to handle '\'.
1335# - \ in script expands to nothing
1336# - \\\ in script expands to \
8ad8b353 1337# - \\\ inside definition expands to nothing
a4623211 1338# - \\\\\\\ inside definition expands to \
1339# - in last line \ has to touch arguments so arguments passing
1340# in new lines (using \) will be supported
1341
bf97e3a6 1342%build_kernel_modules(p:P:m:C:c) \
a4623211 1343%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1344 \
1345%define Opts \\\\\\\
1346%if "%{_target_base_arch}" != "%{_arch}" \\\
1347 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
4d45063a 1348 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
a4623211 1349 %else \\\
1350 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1351 %endif \\\
1352%else \\\
4d45063a 1353 CC="%{kgcc}" \\\
a4623211 1354%endif \
4d45063a 1355%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
a4623211 1356 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1357 \
8b51c37f 1358%{?-C:cd %{-C*}} \
a4623211 1359compile() { \
7ab1c0b6
ER
1360 local L="<" PATCH_SH; \
1361 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
a4623211 1362 set -e -x \
d606f9ca 1363 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
a4623211 1364 \
d606f9ca 1365for cfg in ${cfgs:-dist}; do \
a4623211 1366 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1367 \
8e042a98 1368 rm -rf o \
5f4872d8 1369 install -d o/include/linux o/arch/powerpc/lib \
a4623211 1370 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1371 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1372 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1373 \
1374 set +x \
1375 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1376 set -x \
1377 \
c940d776 1378 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
a4623211 1379 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1380 %{-p*} %{-P*} \\\
1381 %{MakeOpts} \
1382 %else \
1383 install -d o/include/config \
1384 touch o/include/config/MARKER \
21129646 1385 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
a4623211 1386 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1387 %endif \
1388 \
bf97e3a6 1389 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
a4623211 1390 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
220948bb 1391 ${1+"$@"} \\\
bf97e3a6 1392 M=$PWD %{MakeOpts}} \
220948bb 1393 \
a4623211 1394 %{__make} -C %{_kernelsrcdir} modules \\\
1395 ${1+"$@"} \\\
1396 M=$PWD %{MakeOpts} \
1397 \
1398 for MODULE in {%{-m*},}; do \
1399 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1400 done \
1401done \
650cc681 1402%{?-C:cd -} \
a4623211 1403} \
1404compile %{*}\
1405%{nil}
1406
1407
1408# Install kernel modules built by %build_kernel_modules
1409# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1410#
1411# Usage:
1412# %install_kernel_modules -m <modules> -d <directory>
1413#
1414# Options:
3c972982 1415# -m <modules> (required) -- comma-separated list of modules to install,
a4623211 1416# without .ko extension, may be placed in subdirectory
1417# -d <directory> (required) -- in what subdirectory modules should be
1418# installed (eg. misc, kernel/drivers/net)
1419# -s <suffix> -- suffix to use when installing modules, useful when module
1420# with same name exists in kernel already
1421# -n <file> -- name of modprobe config file to use (without .conf extension)
c4bd6177 1422# for defining aliases, only useful with -s
a4623211 1423
1424%install_kernel_modules(m:d:s:n:) \
1425%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1426%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1427%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1428 \
1429%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1430%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
c6bb8dfe 1431 \
0734e6a1 1432__install_kernel_modules() { \
d606f9ca 1433local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
a4623211 1434 \
1435for MODULE in {%{-m*},}; do \
1436 [ -n "${MODULE}" ] || continue \
d606f9ca
ER
1437 for cfg in ${cfgs:-dist}; do \
1438 [ "$cfg" = smp ] && suf=smp || suf= \
1439 MNAME=${MODULE##*/} \
1440 install -D ${MODULE}-$cfg.ko \\\
1441 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b37738c0 1442 %{?-s:install -d %{ModprobeD}$suf \
d606f9ca
ER
1443 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1444 >> %{ModprobeD}$suf/%{-n*}.conf} \
1445 done \
a4623211 1446done \
0734e6a1 1447} \
1448__install_kernel_modules \
a4623211 1449%{nil}
1450
16516cbd 1451# patchset macros
1ebc460a 1452# Author: Elan Ruusamäe <glen@pld-linux.org>
16516cbd
ER
1453#
1454# Usage:
1455# %patchset_source -f <seq(1) format> <start> [<end>]
1456# %patchset_patch <start> [<end>]
1457#
1458# If <end> is omited, it is assumed to be <start>.
1459#
1460# For example in preamble:
1461# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1462# and in %prep:
1463# %patchset_patch 33 44
1464
1465# generate SourceX urls from range START STOP
1466# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1467# The sources start from 10000
cc2d394a 1468%patchset_source(f:b:) %(
8c40a202 1469 base=%{-b*}%{!-b*:10000};
3b7f1777
ER
1470 start=$(expr $base + %1);
1471 end=$(expr $base + %{?2}%{!?2:%{1}});
cc2d394a
ER
1472 # we need to call seq twice as it doesn't allow two formats
1473 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1474 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1475 paste %{tmpdir}/__ps{1,2};
1476 rm -f %{tmpdir}/__ps{1,2};
3b7f1777
ER
1477) \
1478%{nil}
16516cbd
ER
1479
1480# apply sources from %patchset_source
1481# -p specify -pX for %patch line
1482# -b base offset: defaults to 10000
1483%patchset_patch(f:p:b:) %(
8c40a202 1484 base=%{-b*}%{!-b*:10000};
3b7f1777
ER
1485 start=$(expr $base + %1);
1486 end=$(expr $base + %{?2}%{!?2:%{1}});
cc2d394a
ER
1487 echo ": patchset_patch %1%{?2: to %2}";
1488 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
3b7f1777
ER
1489) \
1490%{nil}
16516cbd 1491
c7cb683a 1492# browser plugins v2
1ebc460a 1493# Author: Elan Ruusamäe <glen@pld-linux.org>
c7cb683a
ER
1494#
1495# Usage:
1496# %browser_plugins_add_browser <name> -p <plugindir>
1497#
1498# <name> (required) -- name of the browser. usually %{name}.
1499# -p <plugindir> (required) -- in what directory browser searches for its plugins.
825d0960
ER
1500# -b -- default blacklists
1501# -a <arch> override arch
c7cb683a
ER
1502#
1503# Example:
1504# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1505
1506%_browserpluginsconfdir /etc/browser-plugins
292d3658 1507%_browserpluginsdir %{_libdir}/browser-plugins
c7cb683a
ER
1508%update_browser_plugins /usr/sbin/update-browser-plugins || :
1509
825d0960 1510%browser_plugins_add_browser(p:b:a:) \
2ac4652b 1511 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
c7cb683a 1512 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
825d0960
ER
1513 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1514 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
c7cb683a
ER
1515 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1516 %{-b:cat >> $blacklist_file %{-b*}} \
1517%{nil}
1518
c879189d
ER
1519# Helper for LUA.
1520# split string separated by space into quoted list
1521#
1ebc460a 1522# Author: Elan Ruusamäe <glen@pld-linux.org>
c879189d
ER
1523#
1524# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1525%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1526
1527# adjust /etc/shells by adding and removing shells from there
1ebc460a 1528# Author: Elan Ruusamäe <glen@pld-linux.org>
c879189d
ER
1529#
1530# Usage:
043de7ce
ER
1531# %post -p <lua>
1532# %lua_add_etc_shells /bin/sh /bin/pdksh
c879189d 1533#
043de7ce
ER
1534# %preun -p <lua>
1535# if arg[2] == 0 then
1536# %lua_remove_etc_shells /bin/bash /bin/rbash
1537# end
378ae5eb
ER
1538#
1539# Requirements:
043de7ce
ER
1540# BuildRequires: rpmbuild(macros) >= 1.462
1541#
c879189d 1542
043de7ce 1543%lua_add_etc_shells() \
c879189d
ER
1544t = {}\
1545f = io.open("/etc/shells", "r")\
1546if f then\
1547 for l in f:lines() do t[l]=l; end\
1548 f:close()\
1549end\
1550for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1551 if not t[s] then\
b566b93e 1552 print("Adding "..s.." to /etc/shells")\
c879189d
ER
1553 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1554 end\
1555end\
1556%{nil}
1557
043de7ce
ER
1558%lua_remove_etc_shells() \
1559t = {}\
1560f = io.open("/etc/shells", "r")\
1561if f then\
1562 for l in f:lines() do t[l]=l; end\
1563 f:close()\
1564end\
1565for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1566 print("Removing "..l.." from /etc/shells")\
1567 t[l] = nil\
1568end\
1569s=""\
1570for _, l in pairs(t) do\
1571 s=s..l.."\\n"\
1572end\
1573io.open("/etc/shells", "w"):write(s)\
1574%{nil}
1575
1576# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1577#
1578# Author: Elan Ruusamäe <glen@pld-linux.org>
1579#
1580# Usage:
1581# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1582# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1583#
1584# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1585#
1586# Requirements:
1587# BuildRequires: rpmbuild(macros) >= 1.429
1588#
1589%add_etc_shells(p) %{-p:<lua>}\
1590%{expand:%%lua_add_etc_shells %*}\
1591%{nil}
1592
c879189d 1593%remove_etc_shells(p) %{-p:<lua>}\
b566b93e 1594%{-p:if arg[2] == 0 then}\
043de7ce 1595%{expand:%%lua_remove_etc_shells %*}\
39e5924d 1596%{-p:end} \
c879189d
ER
1597%{nil}
1598
4000ec89
ER
1599# Check syntax for Python files
1600#
1601# Author: Elan Ruusamäe <glen@pld-linux.org>
1602# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1603#
1604# Usage:
1605# %py_lint src
1606#
1607# Requirements:
1608# BuildRequires: python
1609# BuildRequires: rpmbuild(macros) >= 1.469
1610
1611%py_lint() \
1612__py_lint() { \
1613find "$@" -type f -name '*.py' | python -c ' \
1614import sys \
1615import compiler \
1616\
1617err = 0\
1618for f in sys.stdin: \
1619 fd = open(f.strip()) \
1620 c = fd.read() \
1621 fd.close() \
1622 try: \
1623 compiler.parse(c) \
1624 except SyntaxError, e: \
1625 print "py_lint: %s: %s" % (f.strip(), e) \
1626 err = err + 1\
1627\
1628if err: \
1629 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1630 sys.exit(1) \
1631else: \
1632 print >> sys.stderr, "py_lint: Found no syntax errors." \
1633' \
1634}; __py_lint %* \
1635%{nil}
1636
e22fc3d1 1637# vim:ts=4 sw=4 noet syn=spec
This page took 0.543148 seconds and 4 git commands to generate.